#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Aqua
#property indicator_width1 1
#property indicator_color2 Magenta
#property indicator_width2 1
#property indicator_color3 Red
#property indicator_color4 Aqua
#property indicator_color5 Red
#property indicator_color6 Aqua

#include <WebGet.mqh>

extern string   xx                        = "==Mandarine==";
extern int      T3Period                  = 5;
extern int      T3Price                   = PRICE_CLOSE;
extern double   T3Hot                     = 0.7;
extern bool     T3Original                = false;
extern int      Fast                      = 5;
extern int      Slow                      = 20;
extern int      SigShift                  = 0;

extern string   x                         = "==Mandarine Alerts==";
extern bool     UseSound                  = 1;
extern bool     CommentOnChart            = 1;
extern bool     SignalMail                = false;
extern string   NameFileSound             = "train.wav";

extern string   MoneyManagementSetting    = "==Money Management Settings==";
extern bool     UseAutomaticMM            = true;
extern double   Risk                      = 2.50;
extern double   BaseLot                   = 0.05;
extern double   Risk_to_Reward_ratio      = 3.0;
extern double   Range.trailingStop        = 0.25;
extern double   Range.stopLoss            = 0.25;

extern string   HeikenAshiSetting         = "==HeikenAshi Nlma Settings==";
extern bool     ShowHeikenAshi            = true;
extern int      NLMA_TF                   = 0;
extern int      NLMA_Length               = 9;   
extern int      NLMA_Displace             = 0;    
extern double   NLMA_PctFilter            = 0; 
extern int      Step                      = 1;
extern bool     BetterFormula             = true;
extern bool     HAT3Average               = true;
extern double   T3Hot2                    = 0.7;
extern bool     T3Original2               = false;  

extern string   DailyRangeSetting         = "==Daily Range Settings==";
extern bool     Show_RangeBox             = false;
extern bool     Show_Range_hilo_line      = true;
extern bool     Show_Range_vertical_lines = false;
extern bool     Show_Rangehilo_text       = true;

extern string   boxlook                   = "==Box look=="; 
extern string   ex1                       = "Time you want box to end";
extern string   BoxEnd                    = "24:00"; 
extern string   ex2                       = "Period back you want range";
extern string   ex3                       = "box to look in bars";
extern int      BoxLenght                 = 270;  
extern color    BoxColor                  = MidnightBlue;     
extern color    clFont                    = Aqua;
extern color    toprangecolor             = OrangeRed;
extern color    bottomrangecolor          = OrangeRed;
extern color    leftvlinecolor            = Gold;
extern color    rtvlinecolor              = Gold;     
extern int      SizeFont                  = 10;         
extern int      OffSet                    = 0; 
extern int      shift_topline             = 0;
extern int      shift_bottomline          = 0;

extern string   rangecomments             = "==Range Comments==";               
extern int      ShortRange                = 5;
extern int      InterRange                = 10;
extern int      LongRange                 = 20;   

extern string   FiboPivotSetting          = "==Fibo Pivot Settings==";
extern bool     Fhr                       = false;
extern bool     daily                     = false;
extern bool     weekly                    = true;
extern bool     monthly                   = false;
extern color    r3color                   = Magenta;
extern int      r3width                   = 1;
extern color    r2color                   = Red;
extern color    r1color                   = Red;
extern color    pcolor                    = Gold;
extern int      pwidth                    = 1;
extern color    s1color                   = DodgerBlue;
extern color    s2color                   = DodgerBlue;
extern color    s3color                   = Aqua;
extern int      s3width                   = 1;

extern string   _news                     = "==News Filter==";
extern string   CalendarName              = "ForexTSD";
extern int      CalendarID                = 4;     // Calendar's ID on calendar.forex-tsd.com  
extern bool     UseStartDate              = false; 
extern datetime StartDate                 = D'2007.04.10';      
extern bool     AlertMode                 = true;
extern int      AlertTimeGap              = 1;     // Time Gap between News Time and Alert Time in min 
extern bool     DisplayLine               = false; // Display Line Option (Visualization mode) 
extern bool     DisplayText               = false; // Display Text Option (Visualization mode)

extern string   cFilter                   = "==Currency Filter==";
extern bool     USD                       = true;
extern bool     EUR                       = true;
extern bool     GBP                       = true;
extern bool     JPY                       = true;
extern bool     AUD                       = true;
extern bool     CAD                       = true;
extern bool     CHF                       = true;
extern bool     NZD                       = true;

extern string   rFilter                   = "==Rating Filter==";
extern int      MaxRating                 = 3;
extern int      MinRating                 = 3;  


//---- buffers
double   buy[];
double   sell[];
//---- Heiken Ashi Buffers
double   ExtMapBuffer5[];
double   ExtMapBuffer6[];
double   ExtMapBuffer7[];
double   ExtMapBuffer8[];

int      ExtCountedBars=0;
int      last;
int      nDigits;
int      NewsNum;
int      TimeZone;

double   pointvalue;
double   alertTag;
double   avg.rng, rng, sum.rng;
double   emas[][24];
double   alpha;
double   c1;
double   c2;
double   c3;
double   c4;

string   sDate[1000];          // Date
string   sTime[1000];          // Time
string   sCurrency[1000];      // Currency
string   sDescription[1000];   // Description
string   sRating[1000];        // Rating
string   sActual[1000];        // Actual value
string   sForecast[1000];      // Forecast value
string   sPrevious[1000];      // Previous value
string   sImpact[1000];
string   DR;

datetime dt[1000]; 
datetime prevTime, nTime, OpenTime;   

bool     fTime;



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   if (Digits == 4 || Digits == 2) pointvalue = Point;
   else if (Digits == 5 || Digits == 3) pointvalue = 10.0 * Point;
   
//---- indicators
   SetIndexBuffer(0,buy);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,233);
   SetIndexEmptyValue(0,0);
   SetIndexBuffer(1,sell);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexEmptyValue(1,0);
   SetIndexArrow(1,234);

//----
//---- Heiken Ashi indicators
   SetIndexStyle(2,DRAW_HISTOGRAM,0,1,Red);
   SetIndexBuffer(2, ExtMapBuffer5);
   SetIndexStyle(3,DRAW_HISTOGRAM,0,1,Aqua);
   SetIndexBuffer(3, ExtMapBuffer6);
   SetIndexStyle(4,DRAW_HISTOGRAM,0,2,Red);
   SetIndexBuffer(4, ExtMapBuffer7);
   SetIndexStyle(5,DRAW_HISTOGRAM,0,2,Aqua);
   SetIndexBuffer(5, ExtMapBuffer8);
//----
   SetIndexDrawBegin(4,5);
//---- indicator buffers mapping
   SetIndexBuffer(2,ExtMapBuffer5);
   SetIndexBuffer(3,ExtMapBuffer6);
   SetIndexBuffer(4,ExtMapBuffer7);
   SetIndexBuffer(5,ExtMapBuffer8);
   
   double a  = T3Hot2;
          c1 = -a*a*a;
          c2 =  3*(a*a+a*a*a);
          c3 = -3*(2*a*a+a+a*a*a);
          c4 = 1+3*a+a*a*a+3*a*a;

      NLMA_Length = MathMax(1,NLMA_Length);
      if (T3Original2)
      alpha = 2.0/(1.0 + NLMA_Length);
      else alpha = 2.0/(2.0 + (NLMA_Length-1.0)/2.0);
   
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
  {
   ObjectDelete("Fhr_R1 Label");
   ObjectDelete("Fhr_R1 Line");
   ObjectDelete("Fhr_R2 Label");
   ObjectDelete("Fhr_R2 Line");
   ObjectDelete("Fhr_R3 Label");
   ObjectDelete("Fhr_R3 Line");
   ObjectDelete("Fhr_S1 Label");
   ObjectDelete("Fhr_S1 Line");
   ObjectDelete("Fhr_S2 Label");
   ObjectDelete("Fhr_S2 Line");
   ObjectDelete("Fhr_S3 Label");
   ObjectDelete("Fhr_S3 Line");
   ObjectDelete("Fhr_P Label");
   ObjectDelete("Fhr_P Line");
   
   ObjectDelete("D_R1 Label");
   ObjectDelete("D_R1 Line");
   ObjectDelete("D_R2 Label");
   ObjectDelete("D_R2 Line");
   ObjectDelete("D_R3 Label");
   ObjectDelete("D_R3 Line");
   ObjectDelete("D_S1 Label");
   ObjectDelete("D_S1 Line");
   ObjectDelete("D_S2 Label");
   ObjectDelete("D_S2 Line");
   ObjectDelete("D_S3 Label");
   ObjectDelete("D_S3 Line");
   ObjectDelete("D_P Label");
   ObjectDelete("D_P Line");
   //--------------------------------------
   ObjectDelete("W_R1 Label");
   ObjectDelete("W_R1 Line");
   ObjectDelete("W_R2 Label");
   ObjectDelete("W_R2 Line");
   ObjectDelete("W_R3 Label");
   ObjectDelete("W_R3 Line");
   ObjectDelete("W_S1 Label");
   ObjectDelete("W_S1 Line");
   ObjectDelete("W_S2 Label");
   ObjectDelete("W_S2 Line");
   ObjectDelete("W_S3 Label");
   ObjectDelete("W_S3 Line");
   ObjectDelete("W_P Label");
   ObjectDelete("W_P Line");
//--------------------------------------
   ObjectDelete("M_R1 Label");
   ObjectDelete("M_R1 Line");
   ObjectDelete("M_R2 Label");
   ObjectDelete("M_R2 Line");
   ObjectDelete("M_R3 Label");
   ObjectDelete("M_R3 Line");
   ObjectDelete("M_S1 Label");
   ObjectDelete("M_S1 Line");
   ObjectDelete("M_S2 Label");
   ObjectDelete("M_S2 Line");
   ObjectDelete("M_S3 Label");
   ObjectDelete("M_S3 Line");
   ObjectDelete("M_P Label");
   ObjectDelete("M_P Line");
   ObjectsDeleteAll(0,OBJ_HLINE);
   ObjectsDeleteAll(0,OBJ_VLINE);
   ObjectsDeleteAll(0,OBJ_LABEL);
   ObjectsDeleteAll(0,OBJ_RECTANGLE);
   ObjectsDeleteAll(0,OBJ_TEXT);
   ObjectsDeleteAll(1,OBJ_LABEL); 
   Comment(" ");  
   ObjDel();
   return(0);
  }
  
void ReadnPlotCalendar(string fName)
{    
   int i,handle;
   bool rates=false;
   
     
   handle=FileOpen(fName,FILE_CSV|FILE_READ,';');
      if(handle<1)
      {
      Print("File not found ", GetLastError());
      return(false);
      }
   i=0;
   while(!FileIsEnding(handle))
   {
   sDate[i]=FileReadString(handle);          
   sTime[i]=FileReadString(handle);         
   sCurrency[i]=FileReadString(handle);      
   sDescription[i]=FileReadString(handle);   
   sRating[i]=FileReadString(handle);        
   sActual[i]=FileReadString(handle);       
   sForecast[i]=FileReadString(handle);      
   sPrevious[i]=FileReadString(handle);                
   
   int rating = StrToInteger(sRating[i]);
   rates = rating <= MaxRating && rating >= MinRating;
      
   if(!rates) continue;  
   
   if ((sCurrency[i] == "USD") && (!USD)) continue;            
   if ((sCurrency[i] == "EUR") && (!EUR)) continue;            
   if ((sCurrency[i] == "GBP") && (!GBP)) continue;                      
   if ((sCurrency[i] == "JPY") && (!JPY)) continue;
   if ((sCurrency[i] == "AUD") && (!AUD)) continue;
   if ((sCurrency[i] == "CAD") && (!CAD)) continue;                     
   if ((sCurrency[i] == "CHF") && (!CHF)) continue;  
   if ((sCurrency[i] == "NZD") && (!NZD)) continue;   
      
   dt[i] = StrToTime(sDate[i]+" "+sTime[i])+TimeZone*3600;
   if(rating == 3) sImpact[i] = "High";
   if(rating == 2) sImpact[i] = "Medium";
   if(rating == 1) sImpact[i] = "Low";
   
   string info = i+"_"+TimeToStr(dt[i])+" "+sCurrency[i]+" "+" "+sDescription[i]+" "+sImpact[i];
   color c=Yellow ;
   
   if (sCurrency[i] == "USD") c = Blue;  
   if (sCurrency[i] == "EUR") c = Pink; 
   if (sCurrency[i] == "GBP") c = Red;
   if (sCurrency[i] == "JPY") c = Orange;            
   if (sCurrency[i] == "AUD") c = Green;       
   if (sCurrency[i] == "CAD") c = Gray;
   if (sCurrency[i] == "CHF") c = Green;
   if (sCurrency[i] == "NZD") c = Lime;  
      
      if (DisplayText)
      {
      ObjectCreate("TSDT"+i, OBJ_TEXT, 0, dt[i], Close[0]);
      ObjectSet("TSDT"+i, OBJPROP_COLOR, c);          
      ObjectSetText("TSDT"+i,sCurrency[i] + " " + sDescription[i] + " ",8);          
      ObjectSet("TSDT"+i, OBJPROP_ANGLE, 90);          
      }   
      if (DisplayLine)
      {         
      ObjectCreate("TSDL"+i, OBJ_VLINE, 0, dt[i], Close[0]);
      ObjectSet("TSDL"+i, OBJPROP_COLOR, c);                    
      ObjectSet("TSDL"+i, OBJPROP_STYLE, STYLE_DOT);                    
      ObjectSet("TSDL"+i, OBJPROP_BACK, true);          
      ObjectSetText("TSDL"+i,sDescription[i] + "  ",8);          
      }
   i++;
   }
   NewsNum = i;
   
return(0);
}
string ForexTSD_Calendar()
{
   if(!UseStartDate)
   datetime StartWeek = iTime(NULL,PERIOD_W1,0);
   else 
   StartWeek = StartDate;
   
   string StartYear  = TimeYear (StartWeek);
   if (TimeMonth(StartWeek)>9) string StartMonth = TimeMonth(StartWeek);
   else StartMonth = "0" + TimeMonth(StartWeek);
   if (TimeDay(StartWeek)>9) string StartDay   = TimeDay(StartWeek);
   else StartDay = "0" + TimeDay(StartWeek);
   
   string StartTime = StartYear + StartMonth + StartDay;  
      
   string WebAdress = "http://calendar.forex-tsd.com/calendar.php?csv=1&date="+StartTime+"&calendar[]="+CalendarID;
   string result = forextsd_com_webget(WebAdress);
      
   if(result != "") 
   {
   string CalName = "ForexTSD_"+StartYear+"-"+StartMonth+"-"+StartDay+".csv";
   
   Print(CalName," is OK");
   
   int handle=FileOpen(CalName,FILE_CSV|FILE_WRITE,';');
         
      if(handle>0)
      {
      FileWrite(handle, result);
      FileClose(handle);
      }
   }
   else CalName = "";
  
   return(CalName);   
}
//------------------------------------------------------------------  

//------------------------------------------------------------------
int start()
  {
      double emaf11,emaf12,emas21,emas22,t3;
      int counted_bars=IndicatorCounted();
      int j,limit;
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
      limit = MathMin(Bars-counted_bars,Bars-1);
            
      for(j=limit; j>=0; j--)
      {
      t3     = iCustom(NULL,0,"T3 basic",T3Period,T3Price,T3Hot,T3Original,0,j+SigShift);
      emaf11 = iMA(NULL,0,Fast,0,MODE_EMA,PRICE_CLOSE,j+SigShift);
      emaf12 = iMA(NULL,0,Fast,0,MODE_EMA,PRICE_CLOSE,j+1+SigShift);
      emas21 = iMA(NULL,0,Slow,0,MODE_EMA,PRICE_OPEN,j+SigShift);
      emas22 = iMA(NULL,0,Slow,0,MODE_EMA,PRICE_OPEN,j+1+SigShift);
   	
      if (emaf11 > emas21 && emaf12 <= emas22 && emaf11 > t3) {
         buy[j] = Low[j] - iATR(NULL,0,20,j)/2.0;
      if (alertTag!= Time[0])
         {
         if (UseSound == 1) 
	         PlaySound(NameFileSound);
         if (CommentOnChart == 1) 
             Alert(Symbol(),"  ",Period(),"Mandarine cross Buy");
         if (SignalMail) SendMail("[Signal Alert from Mandarine System]",  " [" + TimeCurrent() + "] " + "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Mandarine cross Buy");
         }
            alertTag = Time[0];
      }
      else if (emaf11 < emas21 && emaf12 >= emas22 && emaf11 < t3) {
         sell[j] = High[j] + iATR(NULL,0,20,j)/2.0;
         if ( alertTag!= Time[0])
         {
         if (UseSound == 1) 
	         PlaySound(NameFileSound);
         if (CommentOnChart == 1) 
             Alert(Symbol(),"  ",Period(),"Mandarine cross Sell");
         if (SignalMail) SendMail("[Signal Alert from Mandarine System]",  " [" + TimeCurrent() + "] " + "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Mandarine cross Sell");
         }
            alertTag = Time[0];
      }
   }  
   
//+------------------------------------------------------------------+
//| Heiken Ashi indicator iteration function                              
//+------------------------------------------------------------------+
if (ShowHeikenAshi)
{
   double maOpen, maClose, maLow, maHigh;
   double haOpen, haClose, haLow, haHigh;   
   counted_bars = IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
      limit = Bars-counted_bars;
      if (ArrayRange(emas,0) != Bars) ArrayResize(emas,Bars);
         
      for(int pos=limit; pos >= 0; pos--)
      {
      if (HAT3Average)
      {
      maOpen  = iT3(Open[pos] ,pos, 0);
      maClose = iT3(Close[pos],pos, 6);
      maLow   = iT3(Low[pos]  ,pos,12);
      maHigh  = iT3(High[pos] ,pos,18);
      }
      else
      {
      maOpen  = iCustom(NULL,NLMA_TF,"NonLagMA_v7.1.1",PRICE_OPEN, NLMA_Length,NLMA_Displace,NLMA_PctFilter,1,0,pos);
      maClose = iCustom(NULL,NLMA_TF,"NonLagMA_v7.1.1",PRICE_CLOSE,NLMA_Length,NLMA_Displace,NLMA_PctFilter,1,0,pos);
      maLow   = iCustom(NULL,NLMA_TF,"NonLagMA_v7.1.1",PRICE_LOW,  NLMA_Length,NLMA_Displace,NLMA_PctFilter,1,0,pos);
      maHigh  = iCustom(NULL,NLMA_TF,"NonLagMA_v7.1.1",PRICE_HIGH, NLMA_Length,NLMA_Displace,NLMA_PctFilter,1,0,pos);
      }
      
      if (BetterFormula) {
               if (maHigh!=maLow)
                     haClose = (maOpen+maClose)/2+(((maClose-maOpen)/(maHigh-maLow))*MathAbs((maClose-maOpen)/2));
               else  haClose = (maOpen+maClose)/2; }
         else        haClose = (maOpen+maHigh+maLow+maClose)/4;
                     haOpen   = (ExtMapBuffer7[pos+1]+ExtMapBuffer8[pos+1])/2;
                     haHigh   = MathMax(maHigh, MathMax(haOpen,haClose));
                     haLow    = MathMin(maLow,  MathMin(haOpen,haClose));

         if (haOpen<haClose) { ExtMapBuffer5[pos]=haLow;  ExtMapBuffer6[pos]=haHigh; } 
         else                { ExtMapBuffer5[pos]=haHigh; ExtMapBuffer6[pos]=haLow;  } 
                               ExtMapBuffer7[pos]=haOpen;
                               ExtMapBuffer8[pos]=haClose;
      
      //
      //
      //
      //
      //

      if (Step>0)
      {
         if( MathAbs(ExtMapBuffer5[pos]-ExtMapBuffer5[pos+1]) < Step*pointvalue) ExtMapBuffer5[pos]=ExtMapBuffer5[pos+1];
         if( MathAbs(ExtMapBuffer6[pos]-ExtMapBuffer6[pos+1]) < Step*pointvalue) ExtMapBuffer6[pos]=ExtMapBuffer6[pos+1];
         if( MathAbs(ExtMapBuffer7[pos]-ExtMapBuffer7[pos+1]) < Step*pointvalue) ExtMapBuffer7[pos]=ExtMapBuffer7[pos+1];
         if( MathAbs(ExtMapBuffer8[pos]-ExtMapBuffer8[pos+1]) < Step*pointvalue) ExtMapBuffer8[pos]=ExtMapBuffer8[pos+1];
      }            
   }
 }
   
   
   datetime cTime = iTime(NULL,PERIOD_W1,0);
   if (fTime || (TimeCurrent() > cTime && cTime > prevTime))
   {
   string gmt = forextsd_com_webget("http://calendar.forex-tsd.com/gmt.php");
   if(gmt!="") datetime gmtime = StrToTime(gmt);
   else return(0);
   
   int tz = NormalizeDouble((TimeCurrent() - gmtime)/3600.0,0);
   if ( tz < 24) TimeZone = tz;  
   string cName = ForexTSD_Calendar();  
      
   if(cName != "")
   {   
   ReadnPlotCalendar(cName);
   fTime = false;
   prevTime = cTime;
   }
   else 
   {  
   return(0);
   }
   }
   if(AlertMode && TimeToAlert() && TimeCurrent() > nTime) 
   {
   Alert("Upcoming News! Be ready!"); 
   nTime = TimeCurrent() + AlertTimeGap*60;
   }           
  //----------------------------------------------------------------------------- Get new 4hr ---------------
   double Fhr_rates_d1[2][6],Fhr_yesterday_close,Fhr_yesterday_high,Fhr_yesterday_low;
   ArrayCopyRates(Fhr_rates_d1, Symbol(), 240);
   if(DayOfWeek() == 1)
   {
   if(TimeDayOfWeek(iTime(Symbol(),240,1)) == 5)
   {
   Fhr_yesterday_close = Fhr_rates_d1[1][4];
   Fhr_yesterday_high  = Fhr_rates_d1[1][3];
   Fhr_yesterday_low   = Fhr_rates_d1[1][2];
   }
   else
   {
   for(int f = 5;f >= 0; f--)
   {
   if(TimeDayOfWeek(iTime(Symbol(),240,f)) == 5)
   {
   Fhr_yesterday_close = Fhr_rates_d1[f][4];
   Fhr_yesterday_high  = Fhr_rates_d1[f][3];
   Fhr_yesterday_low   = Fhr_rates_d1[f][2];
   }     
   }    
   }
   }
   else
   {
   Fhr_yesterday_close = Fhr_rates_d1[1][4];
   Fhr_yesterday_high  = Fhr_rates_d1[1][3];
   Fhr_yesterday_low   = Fhr_rates_d1[1][2];
   }
   double Fhr_R  = Fhr_yesterday_high - Fhr_yesterday_low;//range
   double Fhr_p  = (Fhr_yesterday_high + Fhr_yesterday_low + Fhr_yesterday_close)/3;// Standard Pivot
   double Fhr_r3 = Fhr_p + (Fhr_R * 1.000);
   double Fhr_r2 = Fhr_p + (Fhr_R * 0.618);
   double Fhr_r1 = Fhr_p + (Fhr_R * 0.382);
   double Fhr_s1 = Fhr_p - (Fhr_R * 0.382);
   double Fhr_s2 = Fhr_p - (Fhr_R * 0.618);
   double Fhr_s3 = Fhr_p - (Fhr_R * 1.000);
   double Fhr_day_high = 0;
   double Fhr_day_low  = 0;
   double Fhr_nQ = 0;
   double Fhr_nD = 0;
   double Fhr_D  = 0;
   double Fhr_Q  = 0;
   Fhr_day_high  = Fhr_rates_d1[0][3];
   Fhr_day_low   = Fhr_rates_d1[0][2];
   Fhr_D = (Fhr_day_high - Fhr_day_low);
   Fhr_Q = (Fhr_yesterday_high - Fhr_yesterday_low);
   if (Fhr_Q > 5) 
   {
	Fhr_nQ = Fhr_Q;
   }
   else
   {
	Fhr_nQ = Fhr_Q*10000;
   }

   if (Fhr_D > 5)
   {
	Fhr_nD = Fhr_D;
   }
   else
   {
	Fhr_nD = Fhr_D*10000;
   }
   if (StringSubstr(Symbol(),3,3)=="JPY") {
   Fhr_nQ=Fhr_nQ/100;
   Fhr_nD=Fhr_nD/100;     
   }
//------------------------------------------------------------------DAILY--------------------------------------------------------------
   double D_rates_d1[2][6],D_yesterday_close,D_yesterday_high,D_yesterday_low;
   ArrayCopyRates(D_rates_d1, Symbol(), 1440);
   if(DayOfWeek() == 1)
   {
   if(TimeDayOfWeek(iTime(Symbol(),1440,1)) == 5)
   {
   D_yesterday_close = D_rates_d1[1][4];
   D_yesterday_high  = D_rates_d1[1][3];
   D_yesterday_low   = D_rates_d1[1][2];
   }
   else
   {
   for(int d = 5; d >= 0; d--)
   {
   if(TimeDayOfWeek(iTime(Symbol(),1440,d)) == 5)
   {
   D_yesterday_close = D_rates_d1[d][4];
   D_yesterday_high  = D_rates_d1[d][3];
   D_yesterday_low   = D_rates_d1[d][2];
   }     
   }    
   }
   }
   else
   {
   D_yesterday_close = D_rates_d1[1][4];
   D_yesterday_high  = D_rates_d1[1][3];
   D_yesterday_low   = D_rates_d1[1][2];
   }
   double D_R  =  D_yesterday_high - D_yesterday_low;//range
   double D_p  = (D_yesterday_high + D_yesterday_low + D_yesterday_close)/3;// Standard Pivot
   double D_r3 = D_p + (D_R * 1.000);
   double D_r2 = D_p + (D_R * 0.618);
   double D_r1 = D_p + (D_R * 0.382);
   double D_s1 = D_p - (D_R * 0.382);
   double D_s2 = D_p - (D_R * 0.618);
   double D_s3 = D_p - (D_R * 1.000);
   double D_day_high = 0;
   double D_day_low  = 0;
   double D_nQ = 0;
   double D_nD = 0;
   double D_D  = 0;
   double D_Q  = 0;
   D_day_high  = D_rates_d1[0][3];
   D_day_low   = D_rates_d1[0][2];
   D_D = (D_day_high - D_day_low);
   D_Q = (D_yesterday_high - D_yesterday_low);
   if (D_Q > 5) 
   {
	D_nQ = D_Q;
   }
   else
   {
	D_nQ = D_Q*10000;
   }

   if (D_D > 5)
   {
	D_nD = D_D;
   }
   else
   {
	D_nD = D_D*10000;
   }
   if (StringSubstr(Symbol(),3,3)=="JPY") {
   D_nQ=D_nQ/100;
   D_nD=D_nD/100;     
   }
//----------------------------------------------------------------------------- Weekly ---------------
   double W_rates_d1[2][6],W_yesterday_close,W_yesterday_high,W_yesterday_low;
   ArrayCopyRates(W_rates_d1, Symbol(), 10080);
//   if(DayOfWeek() == 1)
//   {
//   if(TimeDayOfWeek(iTime(Symbol(),10080,1)) == 5)
//   {
//   W_yesterday_close = W_rates_d1[1][4];
//   W_yesterday_high  = W_rates_d1[1][3];
//   W_yesterday_low   = W_rates_d1[1][2];
//   }
//   else
//   {
//   for(int z = 5; z >= 0; z--)
//   {
//   if(TimeDayOfWeek(iTime(Symbol(),10080,z)) == 5)
//   {
//   W_yesterday_close = W_rates_d1[z][4];
//   W_yesterday_high  = W_rates_d1[z][3];
//   W_yesterday_low   = W_rates_d1[z][2];
//   }     
//   }    
//   }
//   }
//   else
//   {
   W_yesterday_close = W_rates_d1[1][4];
   W_yesterday_high  = W_rates_d1[1][3];
   W_yesterday_low   = W_rates_d1[1][2];
//   }
   double W_R =  W_yesterday_high - W_yesterday_low;//range
   double W_p = (W_yesterday_high + W_yesterday_low + W_yesterday_close)/3;// Standard Pivot
   double W_r3 = W_p + (W_R * 1.000);
   double W_r2 = W_p + (W_R * 0.618);
   double W_r1 = W_p + (W_R * 0.382);
   double W_s1 = W_p - (W_R * 0.382);
   double W_s2 = W_p - (W_R * 0.618);
   double W_s3 = W_p - (W_R * 1.000);
   double W_day_high = 0;
   double W_day_low  = 0;
   double W_nQ = 0;
   double W_nD = 0;
   double W_D  = 0;
   double W_Q  = 0;
   W_day_high  = W_rates_d1[0][3];
   W_day_low   = W_rates_d1[0][2];
   W_D = (W_day_high - W_day_low);
   W_Q = (W_yesterday_high - W_yesterday_low);
   if (W_Q > 5) 
   {
	W_nQ = W_Q;
   }
   else
   {
	W_nQ = W_Q*10000;
   }

   if (W_D > 5)
   {
	W_nD = W_D;
   }
   else
   {
	W_nD = W_D*10000;
   }
   if (StringSubstr(Symbol(),3,3)=="JPY") {
   W_nQ=W_nQ/100;
   W_nD=W_nD/100;     
   }
//-------------------------------------------------------------MONTHLY-------------------------------------------
   double M_rates_d1[2][6],M_yesterday_close,M_yesterday_high,M_yesterday_low;
   ArrayCopyRates(M_rates_d1, Symbol(), 43200);
   if(DayOfWeek() == 1)
   {
   if(TimeDayOfWeek(iTime(Symbol(),43200,1)) == 5)
   {
   M_yesterday_close = M_rates_d1[1][4];
   M_yesterday_high  = M_rates_d1[1][3];
   M_yesterday_low   = M_rates_d1[1][2];
   }
   else
   {
   for(int m = 5; m >= 0; m--)
   {
   if(TimeDayOfWeek(iTime(Symbol(),43200,m)) == 5)
   {
   M_yesterday_close = M_rates_d1[m][4];
   M_yesterday_high  = M_rates_d1[m][3];
   M_yesterday_low   = M_rates_d1[m][2];
   }     
   }    
   }
   }
   else
   {
   M_yesterday_close = M_rates_d1[1][4];
   M_yesterday_high  = M_rates_d1[1][3];
   M_yesterday_low   = M_rates_d1[1][2];
   }
   double M_R =  M_yesterday_high - M_yesterday_low;//range
   double M_p = (M_yesterday_high + M_yesterday_low + M_yesterday_close)/3;// Standard Pivot
   double M_r3 = M_p + (M_R * 1.000);
   double M_r2 = M_p + (M_R * 0.618);
   double M_r1 = M_p + (M_R * 0.382);
   double M_s1 = M_p - (M_R * 0.382);
   double M_s2 = M_p - (M_R * 0.618);
   double M_s3 = M_p - (M_R * 1.000);
   double M_day_high = 0;
   double M_day_low  = 0;
   double M_nQ = 0;
   double M_nD = 0;
   double M_D  = 0;
   double M_Q  = 0;
   M_day_high  = M_rates_d1[0][3];
   M_day_low   = M_rates_d1[0][2];
   M_D = (M_day_high - M_day_low);
   M_Q = (M_yesterday_high - M_yesterday_low);
   if (M_Q > 5) 
   {
	M_nQ = M_Q;
   }
   else
   {
	M_nQ = M_Q*10000;
   }

   if (M_D > 5)
   {
	M_nD = M_D;
   }
   else
   {
	M_nD = M_D*10000;
   }
   if (StringSubstr(Symbol(),3,3)=="JPY") {
   M_nQ=M_nQ/100;
   M_nD=M_nD/100;     
   }
//--------------------------------------------------------------------------------------------------------------
//+------------------------------------------------------------------+
//| Daily Range iteration function                              
//+------------------------------------------------------------------+ 
   int R1=0,R5=0,R10=0,R20=0,RAvg=0;
   int RoomUp=0,RoomDown=0,StopLoss_Long=0,StopLoss_Short=0;
   int i=0;
   double trailingStop;
   double SL_Long=0,SL_Short=0;
   double low0=0,high0=0,low1=0,high1=0;
   
   R1 =  (iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/pointvalue;
   for(i=1;i<=5;i++)
   R5 = R5  +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/pointvalue;
   for(i=1;i<=10;i++)
   R10 = R10 +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/pointvalue;
   for(i=1;i<=20;i++)
   R20 = R20 +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/pointvalue;

   R5 = R5/ShortRange;
   R10 = R10/InterRange;
   R20 = R20/LongRange;
   RAvg  =  (R1+R5+R10+R20)/4;    

   low0  =  iLow(NULL,PERIOD_D1,0);
   high0 =  iHigh(NULL,PERIOD_D1,0);
   low1  =  iLow(NULL,PERIOD_D1,1);
   high1 =  iHigh(NULL,PERIOD_D1,1);
   RoomUp   =  RAvg - (Bid - low0)/pointvalue;
   RoomDown =  RAvg - (high0 - Bid)/pointvalue;
   StopLoss_Long  =  RoomUp/Risk_to_Reward_ratio;
   SL_Long        =  Bid - StopLoss_Long*pointvalue;
   StopLoss_Short =  RoomDown/Risk_to_Reward_ratio;
   SL_Short       =  Bid + StopLoss_Short*pointvalue; 
   trailingStop   = Range.trailingStop*RAvg;
      
   RefreshRates();
   double step   = MarketInfo(Symbol(),MODE_LOTSTEP);
   double minLot = MarketInfo(Symbol(),MODE_MINLOT);
   double maxLot = MarketInfo(Symbol(),MODE_MAXLOT);
   double lots   = BaseLot;
   if (UseAutomaticMM)
   {
      if (Risk>0)
      {
         lots = AccountFreeMargin()*(Risk/100.0)/(R1*Range.stopLoss*MarketInfo(Symbol(),MODE_TICKVALUE)/pointvalue);
      }

   string sComment   = "";
   string sp         = "---------------------------------------------------\n";
   string NL         = "\n";
   
   for (i=0; i<=NewsNum-1; i++)
   { 
   if(TimeCurrent()> dt[i-1] && TimeCurrent() <= dt[i])
   {
   OpenTime = dt[i];
   string upcomNews = sCurrency[i]+" "+sDescription[i]+" Impact=" + sImpact[i]+" Actual=" + sPrevious[i]+" Forecast=" + sForecast[i];  
   string upcomTime = TimeToStr(dt[i]);  
         
   if (i-1 >= 0)
   {
   string prevNews = sCurrency[i-1]+" "+sDescription[i-1]+" Impact=" + sImpact[i]; 
   string prevTime = TimeToStr(dt[i-1]);
   }
   }
      
   if(OpenTime > 0 && OpenTime < dt[i])
   {
   string nextNews = sCurrency[i]+" "+sDescription[i]+" Impact=" + sImpact[i]+" Actual=" + sPrevious[i]+" Forecast=" + sForecast[i]; 
   string nextTime = TimeToStr(dt[i]);
   break;
   }
   }
   sComment = sp;
   sComment = sComment+"Mandarine Trading System"+NL; 
   sComment = sComment+"ForexTSD Calendar:"+NL;
    
   if(TimeZone >= 0)
   
   sComment = sComment+"Broker\'s Time Zone : GMT + " + TimeZone + NL;
   else
   sComment = sComment+"Broker\'s Time Zone : GMT - " + MathAbs(TimeZone) + NL;
   
   if(MarketInfo(Symbol(),MODE_SWAPLONG)>0) string swap="longs,";
   else swap="shorts.";
   if(MarketInfo(Symbol(),MODE_SWAPLONG)<0 && MarketInfo(Symbol(),MODE_SWAPSHORT)<0) swap="your broker. ";
   int Spread = NormalizeDouble((Ask-Bid)/pointvalue,0);
   int Swaplong = NormalizeDouble(MarketInfo(Symbol(),18),2);
   int Swapshort = NormalizeDouble(MarketInfo(Symbol(),19),2); 
   if( StringFind( Symbol(), "JPY", 0) != -1 )
   { nDigits  = 2;}
   else { nDigits  = 4; }  
   
   sComment = sComment+"NEWS :" + NL;
   sComment = sComment+"Previous = " + prevTime  +" "+prevNews  + NL;
   sComment = sComment+"Upcoming = " + upcomTime +" "+upcomNews + NL;
   sComment = sComment+"Next = " + nextTime +" "+nextNews + NL;
   sComment = sComment + sp + NL; 
   sComment = sComment+"Last Tick :" + TimeToStr(CurTime(),TIME_DATE|TIME_SECONDS) + NL; 
   sComment = sComment+"Swap favors " + swap + NL; 
   sComment = sComment+"Swap Long = " + DoubleToStr(Swaplong,nDigits) + NL; 
   sComment = sComment+"Swap Short = " + DoubleToStr(Swapshort,nDigits) + NL; 
   sComment = sComment+"Current Spread = " + DoubleToStr(Spread,nDigits) + NL; 
   sComment = sComment + sp + NL; 
   sComment = sComment+"Average Daily Range = " + RAvg + NL; 
   sComment = sComment+"Prev 01 Day Range = " + R1 + NL;
   sComment = sComment+"Short Term Range = " + R5 + NL;
   sComment = sComment+"Intermediate Range = " + R10 + NL;
   sComment = sComment+"Long Term Range = " + R20 + NL;
   sComment = sComment+"Todays Range = " + R5 + NL;
   sComment = sComment+"Room Up = " + RoomUp + NL;
   sComment = sComment+"Room Down = " + RoomDown + NL;
   sComment = sComment + sp + NL;
   sComment = sComment+"Recommended Lotsize =   " + DoubleToStr(BaseLot,nDigits) +   "Lots"  + NL;
   sComment = sComment+"Risk to Reward_ratio =  " + DoubleToStr(Risk_to_Reward_ratio,nDigits) + NL;
   sComment = sComment+"Maximum StopLosses :"  + NL;
   sComment = sComment+"Long:  " + StopLoss_Long  + " Pips at " + DoubleToStr(SL_Long,nDigits)  + NL;
   sComment = sComment+"Short: " + StopLoss_Short + " Pips at " + DoubleToStr(SL_Short,nDigits) + NL;
   sComment = sComment+"Trailing Stop = " + DoubleToStr(trailingStop,nDigits) +  NL; 
   sComment = sComment + sp + NL; 
  
   Comment(sComment);        

//---------------------------------------------------------------------4hr Pivot Lines --------------------
if (Fhr==true)
{
   if(ObjectFind("Fhr_R1 label") != 0)
   {
      ObjectCreate("Fhr_R1 label", OBJ_TEXT, 0, Time[0], Fhr_r1);
      ObjectSetText("Fhr_R1 label", "Fhr_R1 " +DoubleToStr(Fhr_r1,4), 8, "Arial", EMPTY);
   }
   else
   {
   ObjectMove("Fhr_R1 label", 0, Time[0], Fhr_r1);
   }

   if(ObjectFind("Fhr_R2 label") != 0)
   {
      ObjectCreate("Fhr_R2 label", OBJ_TEXT, 0, Time[20], Fhr_r2);
      ObjectSetText("Fhr_R2 label", "Fhr_R2 " +DoubleToStr(Fhr_r2,4), 8, "Arial", EMPTY);
   }
   else
   {
      ObjectMove("Fhr_R2 label", 0, Time[0], Fhr_r2);
   }

   if(ObjectFind("Fhr_R3 label") != 0)
   {
      ObjectCreate("Fhr_R3 label", OBJ_TEXT, 0, Time[20], Fhr_r3);
      ObjectSetText("Fhr_R3 label", "Fhr_R3 " +DoubleToStr(Fhr_r3,4), 8, "Arial", EMPTY);
   }
   else
   {
      ObjectMove("Fhr_R3 label", 0, Time[0], Fhr_r3);
   }

   if(ObjectFind("Fhr_P label") != 0)
   {
      ObjectCreate("Fhr_P label", OBJ_TEXT, 0, Time[0], Fhr_p);
      ObjectSetText("Fhr_P label", "Fhr_Pivot " +DoubleToStr(Fhr_p,4), 8, "Arial",EMPTY);
   }
   else
   {
      ObjectMove("Fhr_P label", 0, Time[0], Fhr_p);
   }

   if(ObjectFind("Fhr_S1 label") != 0)
   {
      ObjectCreate("Fhr_S1 label", OBJ_TEXT, 0, Time[0], Fhr_s1);
      ObjectSetText("Fhr_S1 label", "Fhr_S1 " +DoubleToStr(Fhr_s1,4), 8, "Arial", EMPTY);
   }
   else
   {
      ObjectMove("Fhr_S1 label", 0, Time[0], Fhr_s1);
   }

   if(ObjectFind("Fhr_S2 label") != 0)
   {
      ObjectCreate("Fhr_S2 label", OBJ_TEXT, 0, Time[20], Fhr_s2);
      ObjectSetText("Fhr_S2 label", "Fhr_S2 " +DoubleToStr(Fhr_s2,4), 8, "Arial", EMPTY);
   }
   else
   {
      ObjectMove("Fhr_S2 label", 0, Time[0], Fhr_s2);
   }

   if(ObjectFind("Fhr_S3 label") != 0)
   {
      ObjectCreate("Fhr_S3 label", OBJ_TEXT, 0, Time[20], Fhr_s3);
      ObjectSetText("Fhr_S3 label", "Fhr_S3 " +DoubleToStr(Fhr_s3,4), 8, "Arial", EMPTY);
   }
   else
   {
      ObjectMove("Fhr_S3 label", 0, Time[0], Fhr_s3);
   }

//--- Draw Pivot lines on chart
   if(ObjectFind("Fhr_S1 line") != 0)
   {
      ObjectCreate("Fhr_S1 line", OBJ_HLINE, 0, Time[40], Fhr_s1, Time[0], Fhr_s2);
      ObjectSet("Fhr_S1 line", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet("Fhr_S1 line", OBJPROP_WIDTH, 1);
      ObjectSet("Fhr_S1 line", OBJPROP_COLOR, s1color);
   }
   else
   {
      ObjectMove("Fhr_S1 line", 0, Time[40], Fhr_s1);
   }

   if(ObjectFind("Fhr_S2 line") != 0)
   {
      ObjectCreate("Fhr_S2 line", OBJ_HLINE, 0, Time[40], Fhr_s2, Time[0], Fhr_s2);
      ObjectSet("Fhr_S2 line", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet("Fhr_S2 line", OBJPROP_WIDTH, 1);
      ObjectSet("Fhr_S2 line", OBJPROP_COLOR, s2color);
   }
   else
   {
      ObjectMove("Fhr_S2 line", 0, Time[40], Fhr_s2);
   }

   if(ObjectFind("Fhr_S3 line") != 0)
   {
      ObjectCreate("Fhr_S3 line", OBJ_HLINE, 0, Time[40], Fhr_s3, Time[0], Fhr_s3);
      ObjectSet("Fhr_S3 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("Fhr_S3 line", OBJPROP_WIDTH, s3width);
      ObjectSet("Fhr_S3 line", OBJPROP_COLOR, s3color);
   }
   else
   {
     ObjectMove("Fhr_S3 line", 0, Time[40], Fhr_s3);
   }

   if(ObjectFind("Fhr_P line") != 0)
   {
      ObjectCreate("Fhr_P line", OBJ_HLINE, 0, Time[40], Fhr_p, Time[0], Fhr_p);
      ObjectSet("Fhr_P line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("Fhr_P line", OBJPROP_WIDTH,pwidth);
      ObjectSet("Fhr_P line", OBJPROP_COLOR, pcolor);
   }
   else
   {
      ObjectMove("Fhr_P line", 0, Time[40], Fhr_p);
   }

   if(ObjectFind("Fhr_R1 line") != 0)
   {
      ObjectCreate("Fhr_R1 line", OBJ_HLINE, 0, Time[40], Fhr_r1, Time[0], Fhr_r1);
      ObjectSet("Fhr_R1 line", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet("Fhr_R1 line", OBJPROP_WIDTH, 1);
      ObjectSet("Fhr_R1 line", OBJPROP_COLOR, r1color);
   }
   else
   {
      ObjectMove("Fhr_R1 line", 0, Time[40], Fhr_r1);
   }

   if(ObjectFind("Fhr_R2 line") != 0)
   {
      ObjectCreate("Fhr_R2 line", OBJ_HLINE, 0, Time[40], Fhr_r2, Time[0], Fhr_r2);
      ObjectSet("Fhr_R2 line", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet("Fhr_R2 line", OBJPROP_WIDTH, 1);
      ObjectSet("Fhr_R2 line", OBJPROP_COLOR, r2color);
   }
   else
   {
      ObjectMove("Fhr_R2 line", 0, Time[40], Fhr_r2);
   }

   if(ObjectFind("Fhr_R3 line") != 0)
   {
      ObjectCreate("Fhr_R3 line", OBJ_HLINE, 0, Time[40], Fhr_r3, Time[0], Fhr_r3);
      ObjectSet("Fhr_R3 line", OBJPROP_STYLE, STYLE_SOLID);
      ObjectSet("Fhr_R3 line", OBJPROP_WIDTH, r3width);
      ObjectSet("Fhr_R3 line", OBJPROP_COLOR, r3color);
   }
   else
   {
      ObjectMove("Fhr_R3 line", 0, Time[40], Fhr_r3);
   }
   } 
  //--------------------------------------------------------End of 4 hour 
  //----------------------------------------------------------------------------DAILY Pivot Lines --------------------
   if (daily==true)
   {
   if(ObjectFind("    D_R1 label") != 0)
   {
   ObjectCreate("     D_R1 label", OBJ_TEXT, 0, Time[0], D_r1);
   ObjectSetText("D_R1 label", "D_R1" + DoubleToStr(D_r1,4), 8, "Arial", EMPTY);
   }
   else
   {
   ObjectMove("     D_R1 label", 0, Time[0], D_r1);
   }

   if(ObjectFind("D_R2 label") != 0)
   {
   ObjectCreate("D_R2 label", OBJ_TEXT, 0, Time[20], D_r2);
   ObjectSetText("D_R2 label", "D_R2" + DoubleToStr(D_r2,4), 8, "Arial", EMPTY);
   }
   else
   {
   ObjectMove("D_R2 label", 0, Time[0], D_r2);
   }

   if(ObjectFind("D_R3 label") != 0)
   {
   ObjectCreate("D_R3 label", OBJ_TEXT, 0, Time[20], D_r3);
   ObjectSetText("D_R3 label", "D_R3" + DoubleToStr(D_r3,4), 8, "Arial", EMPTY);
   }
   else
   {
   ObjectMove("D_R3 label", 0, Time[0], D_r3);
   }

   if(ObjectFind("D_P label") != 0)
   {
   ObjectCreate("D_P label", OBJ_TEXT, 0, Time[0], D_p);
   ObjectSetText("D_P label", "D_Pivot" + DoubleToStr(D_p,4), 8, "Arial",EMPTY);
   }
   else
   {
   ObjectMove("D_P label", 0, Time[0], D_p);
   }

   if(ObjectFind("D_S1 label") != 0)
   {
   ObjectCreate("D_S1 label", OBJ_TEXT, 0, Time[0], D_s1);
   ObjectSetText("D_S1 label", "D_S1" + DoubleToStr(D_s1,4), 8, "Arial", EMPTY);
   }
   else
   {
   ObjectMove("D_S1 label", 0, Time[0], D_s1);
   }

   if(ObjectFind("D_S2 label") != 0)
   {
   ObjectCreate("D_S2 label", OBJ_TEXT, 0, Time[20], D_s2);
   ObjectSetText("D_S2 label", "D_S2" + DoubleToStr(D_s2,4), 8, "Arial", EMPTY);
   }
   else
   {
   ObjectMove("D_S2 label", 0, Time[0], D_s2);
   }

   if(ObjectFind("D_S3 label") != 0)
   {
   ObjectCreate("D_S3 label", OBJ_TEXT, 0, Time[20], D_s3);
   ObjectSetText("D_S3 label", "D_S3" + DoubleToStr(D_s3,4), 8, "Arial", EMPTY);
   }
   else
   {
   ObjectMove("D_S3 label", 0, Time[0], D_s3);
   }

   if(ObjectFind("D_S1 line") != 0)
   {
   ObjectCreate("D_S1 line", OBJ_HLINE, 0, Time[0], D_s1, Time[0], D_s1);
   ObjectSet("D_S1 line", OBJPROP_STYLE, STYLE_DOT);
   ObjectSet("D_S1 line", OBJPROP_WIDTH, 1);
   ObjectSet("D_S1 line", OBJPROP_COLOR, s1color);
   }
   else
   {
   ObjectMove("D_S1 line", 0, Time[40], D_s1);
   }

   if(ObjectFind("D_S2 line") != 0)
   {
   ObjectCreate("D_S2 line", OBJ_HLINE, 0, Time[40], D_s2);
   ObjectSet("D_S2 line", OBJPROP_STYLE, STYLE_DOT);
   ObjectSet("D_S2 line", OBJPROP_WIDTH, 1);
   ObjectSet("D_S2 line", OBJPROP_COLOR, s2color);
   }
   else
   {
   ObjectMove("D_S2 line", 0, Time[40], D_s2);
   }

   if(ObjectFind("D_S3 line") != 0)
   {
   ObjectCreate("D_S3 line", OBJ_HLINE, 0, Time[40], D_s3);
   ObjectSet("D_S3 line", OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet("D_S3 line", OBJPROP_WIDTH, s3width);
   ObjectSet("D_S3 line", OBJPROP_COLOR, s3color);
   }
   else
   {
   ObjectMove("D_S3 line", 0, Time[40], D_s3);
   }

   if(ObjectFind("D_P line") != 0)
   {
   ObjectCreate("D_P line", OBJ_HLINE, 0, Time[40], D_p);
   ObjectSet("D_P line", OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet("D_P line", OBJPROP_WIDTH, pwidth);
   ObjectSet("D_P line", OBJPROP_COLOR, pcolor);
   }
   else
   {
   ObjectMove("D_P line", 0, Time[40], D_p);
   }

   if(ObjectFind("D_R1 line") != 0)
   {
   ObjectCreate("D_R1 line", OBJ_HLINE, 0, Time[40], D_r1);
   ObjectSet("D_R1 line", OBJPROP_STYLE, STYLE_DOT);
   ObjectSet("D_R1 line", OBJPROP_WIDTH, 1);
   ObjectSet("D_R1 line", OBJPROP_COLOR, r1color);
   }
   else
   {
   ObjectMove("D_R1 line", 0, Time[40], D_r1);
   }

   if(ObjectFind("D_R2 line") != 0)
   {
   ObjectCreate("D_R2 line", OBJ_HLINE, 0, Time[40], D_r2);
   ObjectSet("D_R2 line", OBJPROP_STYLE, STYLE_DOT);
   ObjectSet("D_R2 line", OBJPROP_WIDTH, 1);
   ObjectSet("D_R2 line", OBJPROP_COLOR, r2color);
   }
   else
   {
   ObjectMove("D_R2 line", 0, Time[40], D_r2);
   }

   if(ObjectFind("D_R3 line") != 0)
   {
   ObjectCreate("D_R3 line", OBJ_HLINE, 0, Time[40], D_r3);
   ObjectSet("D_R3 line", OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet("D_R3 line", OBJPROP_WIDTH, r3width);
   ObjectSet("D_R3 line", OBJPROP_COLOR, r3color);
   }
   else
   {
   ObjectMove("D_R3 line", 0, Time[40], D_r3);
   }
   }
//-------------=---------------------------------------------------------------------End of DAILY
   //---------------------------------------------------------------------WEEKLY Pivot Lines --------------------
   if (weekly==true)
   {
   if(ObjectFind("W_R1 label") != 0)
   {
   ObjectCreate("W_R1 label", OBJ_TEXT, 0, Time[0], W_r1);
   ObjectSetText("W_R1 label", "W_R1 " +DoubleToStr(W_r1,4), 8, "Arial", EMPTY);
   }
   else
   {
   ObjectMove("W_R1 label", 0, Time[0], W_r1);
   }

   if(ObjectFind("W_R2 label") != 0)
   {
   ObjectCreate("W_R2 label", OBJ_TEXT, 0, Time[20], W_r2);
   ObjectSetText("W_R2 label", "W_R2 " +DoubleToStr(W_r2,4), 8, "Arial", EMPTY);
   }
   else
   {
   ObjectMove("W_R2 label", 0, Time[0], W_r2);
   }

   if(ObjectFind("W_R3 label") != 0)
   {
   ObjectCreate("W_R3 label", OBJ_TEXT, 0, Time[20], W_r3);
   ObjectSetText("W_R3 label", "W_R3 " +DoubleToStr(W_r3,4), 8, "Arial", EMPTY);
   }
   else
   {
   ObjectMove("W_R3 label", 0, Time[0], W_r3);
   }

   if(ObjectFind("W_P label") != 0)
   {
   ObjectCreate("W_P label", OBJ_TEXT, 0, Time[0], W_p);
   ObjectSetText("W_P label", "W_Pivot " +DoubleToStr(W_p,4), 8, "Arial",EMPTY);
   }
   else
   {
   ObjectMove("W_P label", 0, Time[0], W_p);
   }

   if(ObjectFind("W_S1 label") != 0)
   {
   ObjectCreate("W_S1 label", OBJ_TEXT, 0, Time[0], W_s1);
   ObjectSetText("W_S1 label", "W_S1 " +DoubleToStr(W_s1,4), 8, "Arial", EMPTY);
   }
   else
   {
   ObjectMove("W_S1 label", 0, Time[0], W_s1);
   }

   if(ObjectFind("W_S2 label") != 0)
   {
   ObjectCreate("W_S2 label", OBJ_TEXT, 0, Time[20], W_s2);
   ObjectSetText("W_S2 label", "W_S2 " +DoubleToStr(W_s2,4), 8, "Arial", EMPTY);
   }
   else
   {
   ObjectMove("W_S2 label", 0, Time[0], W_s2);
   }

   if(ObjectFind("W_S3 label") != 0)
   {
   ObjectCreate("W_S3 label", OBJ_TEXT, 0, Time[20], W_s3);
   ObjectSetText("W_S3 label", "W_S3 " +DoubleToStr(W_s3,4), 8, "Arial", EMPTY);
   }
   else
   {
   ObjectMove("W_S3 label", 0, Time[0], W_s3);
   }

   //--- Draw Pivot lines on chart
   if(ObjectFind("W_S1 line") != 0)
   {
   ObjectCreate("W_S1 line", OBJ_HLINE, 0, Time[40], W_s1);
   ObjectSet("W_S1 line", OBJPROP_STYLE, STYLE_DOT);
   ObjectSet("W_S1 line", OBJPROP_WIDTH, 1);
   ObjectSet("W_S1 line", OBJPROP_COLOR, s1color);
   }
   else
   {
   ObjectMove("W_S1 line", 0, Time[40], W_s1);
   }

   if(ObjectFind("W_S2 line") != 0)
   {
   ObjectCreate("W_S2 line", OBJ_HLINE, 0, Time[40], W_s2);
   ObjectSet("W_S2 line", OBJPROP_STYLE, STYLE_DOT);
   ObjectSet("W_S2 line", OBJPROP_WIDTH, 1);
   ObjectSet("W_S2 line", OBJPROP_COLOR, s2color);
   }
   else
   {
   ObjectMove("W_S2 line", 0, Time[40], W_s2);
   }

   if(ObjectFind("W_S3 line") != 0)
   {
   ObjectCreate("W_S3 line", OBJ_HLINE, 0, Time[40], W_s3);
   ObjectSet("W_S3 line", OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet("W_S3 line", OBJPROP_WIDTH, s3width);
   ObjectSet("W_S3 line", OBJPROP_COLOR, s3color);
   }
   else
   {
   ObjectMove("W_S3 line", 0, Time[40], W_s3);
   }

   if(ObjectFind("W_P line") != 0)
   {
   ObjectCreate("W_P line", OBJ_HLINE, 0, Time[40], W_p);
   ObjectSet("W_P line", OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet("W_P line", OBJPROP_WIDTH, pwidth);
   ObjectSet("W_P line", OBJPROP_COLOR, pcolor);
   }
   else
   {
   ObjectMove("W_P line", 0, Time[40], W_p);
   }

   if(ObjectFind("W_R1 line") != 0)
   {
   ObjectCreate("W_R1 line", OBJ_HLINE, 0, Time[40], W_r1);
   ObjectSet("W_R1 line", OBJPROP_STYLE, STYLE_DOT);
   ObjectSet("W_R1 line", OBJPROP_WIDTH, 1);
   ObjectSet("W_R1 line", OBJPROP_COLOR, r1color);
   }
   else
   {
   ObjectMove("W_R1 line", 0, Time[40], W_r1);
   }

   if(ObjectFind("W_R2 line") != 0)
   {
   ObjectCreate("W_R2 line", OBJ_HLINE, 0, Time[40], W_r2);
   ObjectSet("W_R2 line", OBJPROP_STYLE, STYLE_DOT);
   ObjectSet("W_R2 line", OBJPROP_WIDTH, 1);
   ObjectSet("W_R2 line", OBJPROP_COLOR, r2color);
   }
   else
   {
   ObjectMove("W_R2 line", 0, Time[40], W_r2);
   }

   if(ObjectFind("W_R3 line") != 0)
   {
   ObjectCreate("W_R3 line", OBJ_HLINE, 0, Time[40], W_r3);
   ObjectSet("W_R3 line", OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet("W_R3 line", OBJPROP_WIDTH, r3width);
   ObjectSet("W_R3 line", OBJPROP_COLOR, r3color);
   }
   else
   {
   ObjectMove("W_R3 line", 0, Time[40], W_r3);
   }
   }
   //--------------------------------------------------------------------Monthly Pivot Lines --------------------
   if (monthly == true)
   {
   if(ObjectFind("M_R1 label") != 0)
   {
   ObjectCreate("M_R1 label", OBJ_TEXT, 0, Time[0], M_r1);
   ObjectSetText("M_R1 label", " M_R1 " + DoubleToStr(M_r1,4), 8, "Arial", EMPTY);
   }
   else
   {
   ObjectMove("M_R1 label", 0, Time[0], M_r1);
   }

   if(ObjectFind("M_R2 label") != 0)
   {
   ObjectCreate("M_R2 label", OBJ_TEXT, 0, Time[20], M_r2);
   ObjectSetText("M_R2 label", " M_R2 " + DoubleToStr(M_r2,4), 8, "Arial", EMPTY);
   }
   else
   {
   ObjectMove("M_R2 label", 0, Time[0], M_r2);
   }

   if(ObjectFind("M_R3 label") != 0)
   {
   ObjectCreate("M_R3 label", OBJ_TEXT, 0, Time[20], M_r3);
   ObjectSetText("M_R3 label", " M_R3 " + DoubleToStr(M_r3,4), 8, "Arial", EMPTY);
   }
   else
   {
   ObjectMove("M_R3 label", 0, Time[0], M_r3);
   }

   if(ObjectFind("M_P label") != 0)
   {
   ObjectCreate("M_P label", OBJ_TEXT, 0, Time[0], M_p);
   ObjectSetText("M_P label", "M_Pivot " + DoubleToStr(M_p,4), 8, "Arial",EMPTY);
   }
   else
   {
   ObjectMove("M_P label", 0, Time[0], M_p);
   }

   if(ObjectFind("M_S1 label") != 0)
   {
   ObjectCreate("M_S1 label", OBJ_TEXT, 0, Time[0], M_s1);
   ObjectSetText("M_S1 label", "M_S1 " + DoubleToStr(M_s1,4), 8, "Arial", EMPTY);
   }
   else
   {
   ObjectMove("M_S1 label", 0, Time[0], M_s1);
   }

   if(ObjectFind("M_S2 label") != 0)
   {
   ObjectCreate("M_S2 label", OBJ_TEXT, 0, Time[20], M_s2);
   ObjectSetText("M_S2 label", "S2 " + DoubleToStr(M_s2,4), 8, "Arial", EMPTY);
   }
   else
   {
   ObjectMove("M_S2 label", 0, Time[0], M_s2);
   }

   if(ObjectFind("M_S3 label") != 0)
   {
   ObjectCreate("M_S3 label", OBJ_TEXT, 0, Time[20], M_s3);
   ObjectSetText("M_S3 label", "M_S3 " + DoubleToStr(M_s3,4), 8, "Arial", EMPTY);
   }
   else
   {
   ObjectMove("M_S3 label", 0, Time[0], M_s3);
   }

   //--- Draw Pivot lines on chart
   if(ObjectFind("M_S1 line") != 0)
   {
   ObjectCreate("M_S1 line", OBJ_HLINE, 0, Time[40], M_s1);
   ObjectSet("M_S1 line", OBJPROP_STYLE, STYLE_DOT);
   ObjectSet("M_S1 line", OBJPROP_WIDTH, 1);
   ObjectSet("M_S1 line", OBJPROP_COLOR, s1color);
   }
   else
   {
   ObjectMove("M_S1 line", 0, Time[40], M_s1);
   }

   if(ObjectFind("M_S2 line") != 0)
   {
   ObjectCreate("M_S2 line", OBJ_HLINE, 0, Time[40], M_s2);
   ObjectSet("M_S2 line", OBJPROP_STYLE, STYLE_DOT);
   ObjectSet("M_S2 line", OBJPROP_WIDTH, 1);
   ObjectSet("M_S2 line", OBJPROP_COLOR, s2color);
   }
   else
   {
   ObjectMove("M_S2 line", 0, Time[40], M_s2);
   }

   if(ObjectFind("M_S3 line") != 0)
   {
   ObjectCreate("M_S3 line", OBJ_HLINE, 0, Time[40], M_s3);
   ObjectSet("M_S3 line", OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet("M_S3 line", OBJPROP_WIDTH, s3width);
   ObjectSet("M_S3 line", OBJPROP_COLOR, s3color);
   }
   else
   {
   ObjectMove("M_S3 line", 0, Time[40], M_s3);
   }

   if(ObjectFind("M_P line") != 0)
   {
   ObjectCreate("M_P line", OBJ_HLINE, 0, Time[40], M_p);
   ObjectSet("M_P line", OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet("M_P line", OBJPROP_WIDTH, pwidth);
   ObjectSet("M_P line", OBJPROP_COLOR, pcolor);
   }
   else
   {
   ObjectMove("M_P line", 0, Time[40], M_p);
   }

   if(ObjectFind("M_R1 line") != 0)
   {
   ObjectCreate("M_R1 line", OBJ_HLINE, 0, Time[40], M_r1);
   ObjectSet("M_R1 line", OBJPROP_STYLE, STYLE_DOT);
   ObjectSet("M_R1 line", OBJPROP_WIDTH, 1);
   ObjectSet("M_R1 line", OBJPROP_COLOR, r1color);
   }
   else
   {
   ObjectMove("M_R1 line", 0, Time[40], M_r1);
   }

   if(ObjectFind("M_R2 line") != 0)
   {
   ObjectCreate("M_R2 line", OBJ_HLINE, 0, Time[40], M_r2);
   ObjectSet("M_R2 line", OBJPROP_STYLE, STYLE_DOT);
   ObjectSet("M_R2 line", OBJPROP_WIDTH, 1);
   ObjectSet("M_R2 line", OBJPROP_COLOR, r2color);
   }
   else
   {
   ObjectMove("M_R2 line", 0, Time[40], M_r2);
   }

   if(ObjectFind("M_R3 line") != 0)
   {
   ObjectCreate("M_R3 line", OBJ_HLINE, 0, Time[40], M_r3);
   ObjectSet("M_R3 line", OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet("M_R3 line", OBJPROP_WIDTH, r3width);
   ObjectSet("M_R3 line", OBJPROP_COLOR, r3color);
   }
   else
   {
   ObjectMove("M_R3 line", 0, Time[40], M_r3);
   }
   }
   //---- End of Pivot Line Draw

   double   top, bottom;
   datetime left, right, daybegin, dayend, t4, t99;
   string   boxdaybegin, boxbegin, boxdayend, dhc, dhf;
   int      b1, b2;
   
   right = StrToTime (TimeToStr (TimeCurrent(),TIME_DATE) + " " + BoxEnd);
   if (right > TimeCurrent())
      {
      right = StrToTime (TimeToStr (TimeCurrent()- D'1970.01.01 23:59:59',TIME_DATE) + " " + BoxEnd);
      }
   if (TimeDayOfWeek (right)==0)
      { 
      t99   = StrToTime (TimeToStr  (TimeCurrent()- D'1970.01.01 23:59:59',TIME_DATE) + " " + BoxEnd );
      right = StrToTime (TimeToStr ( t99 + D'1970.01.01 1')); 
      }
      left = StrToTime (TimeToStr ( right - D'1970.01.01 1'* BoxLenght ));
   if (TimeDayOfWeek (left) == 0) 
      { 
      left = StrToTime (TimeToStr ( right - D'1970.01.01 1'* (BoxLenght +48) )); 
      }   
      b1=iBarShift(NULL, 0, left);
      b2=iBarShift(NULL, 0, right);
      top = High [iHighest(NULL,0, MODE_HIGH,b1-b2, b2)];
      bottom=Low [Lowest (NULL, 0, MODE_LOW , b1-b2, b2)];
      
if (Show_RangeBox)
{        
      ObjectCreate ("Box", OBJ_RECTANGLE,0,left,top,right,bottom);
      ObjectSet ("Box", OBJPROP_BACK,true);
      ObjectSet ("Box", OBJPROP_COLOR,BoxColor);
      }
if (Show_Range_hilo_line)
{  
      ObjectCreate ("top",OBJ_HLINE,0,0,top);
      ObjectSet("top", OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("top", OBJPROP_COLOR,toprangecolor);
      ObjectMove("top",0, Time[shift_topline],top);
  
      ObjectCreate ("bottom",OBJ_HLINE,0,0,bottom);
      ObjectSet("bottom", OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("bottom", OBJPROP_COLOR,bottomrangecolor );
      ObjectMove("bottom",0,Time[shift_bottomline],bottom );
      }
if (Show_Range_vertical_lines)
{     
      ObjectCreate ("left", OBJ_VLINE,0,left,0);
      ObjectSet("left", OBJPROP_STYLE,STYLE_DOT);
      ObjectSet("left", OBJPROP_COLOR,leftvlinecolor);
  
      ObjectCreate ("right",OBJ_VLINE,0,right,0);
      ObjectSet("right", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet("right", OBJPROP_COLOR,rtvlinecolor);
      }
if (Show_Rangehilo_text) 
      if (ObjectFind("BoxHigh")<0) ObjectCreate("BoxHigh",OBJ_TEXT,0,0,0);
      ObjectSet("BoxHigh", OBJPROP_TIME1 , right);
      ObjectSet("BoxHigh", OBJPROP_PRICE1 ,top+OffSet*pointvalue);
      ObjectSet("BoxHigh", OBJPROP_COLOR , clFont);
      ObjectSet("BoxHigh", OBJPROP_FONTSIZE,SizeFont);
      ObjectSetText("BoxHigh", "HIGH: "+DoubleToStr(top,Digits));

      if (ObjectFind("BoxLow")<0) ObjectCreate("BoxLow",OBJ_TEXT,0,0,0);
      ObjectSet("BoxLow", OBJPROP_TIME1 , right);
      ObjectSet("BoxLow", OBJPROP_PRICE1, bottom);
      ObjectSet("BoxLow", OBJPROP_COLOR , clFont);
      ObjectSet("BoxLow", OBJPROP_FONTSIZE, SizeFont);
      ObjectSetText("BoxLow", "LOW: "+DoubleToStr(bottom,Digits));
     }
return(0);
}

void ObjDel()
{
   int _GetLastError;
   if(DisplayLine && DisplayText) int obtotal = 0.5*ObjectsTotal(); else obtotal = ObjectsTotal();
   for ( int i = 0; i < obtotal; i ++ )
   {
   if (DisplayLine)
   if ( !ObjectDelete( StringConcatenate( "TSDL", i ) ) )
   {
   _GetLastError = GetLastError();
   } 
   if (DisplayText)
   if( !ObjectDelete( StringConcatenate( "TSDT", i ) ) )
   {
   _GetLastError = GetLastError();
   }
  }
}

bool TimeToAlert()
   {
   bool result = false;
   for (int i=0; i<=NewsNum; i++)
   { 
   datetime AlertTime = dt[i] - AlertTimeGap*60;
      if((TimeCurrent()>= AlertTime && TimeCurrent() <= AlertTime + 60))
      {result=true; break;}
   }
   return(result);
}
double iT3(double price,int shift,int buffer)
{
   int i = Bars-shift-1;
   if (i < 1)
      {
      emas[i][0+buffer] = price;
      emas[i][1+buffer] = price;
      emas[i][2+buffer] = price;
      emas[i][3+buffer] = price;
      emas[i][4+buffer] = price;
      emas[i][5+buffer] = price;
      }
      else
      {
      emas[i][0+buffer] = emas[i-1][0+buffer]+alpha*(price            -emas[i-1][0+buffer]);
      emas[i][1+buffer] = emas[i-1][1+buffer]+alpha*(emas[i][0+buffer]-emas[i-1][1+buffer]);
      emas[i][2+buffer] = emas[i-1][2+buffer]+alpha*(emas[i][1+buffer]-emas[i-1][2+buffer]);
      emas[i][3+buffer] = emas[i-1][3+buffer]+alpha*(emas[i][2+buffer]-emas[i-1][3+buffer]);
      emas[i][4+buffer] = emas[i-1][4+buffer]+alpha*(emas[i][3+buffer]-emas[i-1][4+buffer]);
      emas[i][5+buffer] = emas[i-1][5+buffer]+alpha*(emas[i][4+buffer]-emas[i-1][5+buffer]);
      }
return(c1*emas[i][5+buffer] + c2*emas[i][4+buffer] + c3*emas[i][3+buffer] + c4*emas[i][2+buffer]);

}